Linux Audio

Check our new training course

Loading...
v4.17
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# Translate stack dump function offsets.
  5#
  6# addr2line doesn't work with KASLR addresses.  This works similarly to
  7# addr2line, but instead takes the 'func+0x123' format as input:
  8#
  9#   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
 10#   meminfo_proc_show+0x5/0x568:
 11#   meminfo_proc_show at fs/proc/meminfo.c:27
 12#
 13# If the address is part of an inlined function, the full inline call chain is
 14# printed:
 15#
 16#   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
 17#   native_write_msr+0x6/0x27:
 18#   arch_static_branch at arch/x86/include/asm/msr.h:121
 19#    (inlined by) static_key_false at include/linux/jump_label.h:125
 20#    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
 21#
 22# The function size after the '/' in the input is optional, but recommended.
 23# It's used to help disambiguate any duplicate symbol names, which can occur
 24# rarely.  If the size is omitted for a duplicate symbol then it's possible for
 25# multiple code sites to be printed:
 26#
 27#   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
 28#   raw_ioctl+0x5/0x20:
 29#   raw_ioctl at drivers/char/raw.c:122
 30#
 31#   raw_ioctl+0x5/0xb1:
 32#   raw_ioctl at net/ipv4/raw.c:876
 33#
 34# Multiple addresses can be specified on a single command line:
 35#
 36#   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
 37#   type_show+0x10/0x2d:
 38#   type_show at drivers/video/backlight/backlight.c:213
 39#
 40#   free_reserved_area+0x90/0x123:
 41#   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
 42
 43
 44set -o errexit
 45set -o nounset
 46
 47READELF="${CROSS_COMPILE:-}readelf"
 48ADDR2LINE="${CROSS_COMPILE:-}addr2line"
 49SIZE="${CROSS_COMPILE:-}size"
 50NM="${CROSS_COMPILE:-}nm"
 51
 52command -v awk >/dev/null 2>&1 || die "awk isn't installed"
 53command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed"
 54command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed"
 55command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed"
 56command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed"
 57
 58usage() {
 59	echo "usage: faddr2line <object file> <func+offset> <func+offset>..." >&2
 60	exit 1
 61}
 62
 63warn() {
 64	echo "$1" >&2
 65}
 66
 67die() {
 68	echo "ERROR: $1" >&2
 69	exit 1
 70}
 71
 
 
 
 
 
 
 
 
 
 72# Try to figure out the source directory prefix so we can remove it from the
 73# addr2line output.  HACK ALERT: This assumes that start_kernel() is in
 74# kernel/init.c!  This only works for vmlinux.  Otherwise it falls back to
 75# printing the absolute path.
 76find_dir_prefix() {
 77	local objfile=$1
 78
 79	local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
 
 80	[[ -z $start_kernel_addr ]] && return
 81
 82	local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
 83	[[ -z $file_line ]] && return
 84
 85	local prefix=${file_line%init/main.c:*}
 86	if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
 87		return
 88	fi
 89
 90	DIR_PREFIX=$prefix
 91	return 0
 92}
 93
 94__faddr2line() {
 95	local objfile=$1
 96	local func_addr=$2
 97	local dir_prefix=$3
 98	local print_warnings=$4
 99
100	local func=${func_addr%+*}
101	local offset=${func_addr#*+}
102	offset=${offset%/*}
103	local size=
104	[[ $func_addr =~ "/" ]] && size=${func_addr#*/}
 
 
105
106	if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
107		warn "bad func+offset $func_addr"
108		DONE=1
109		return
110	fi
111
 
 
 
 
 
 
 
 
112	# Go through each of the object's symbols which match the func name.
113	# In rare cases there might be duplicates.
114	file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}')
115	while read symbol; do
116		local fields=($symbol)
117		local sym_base=0x${fields[0]}
118		local sym_type=${fields[1]}
119		local sym_end=${fields[3]}
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
120
121		# calculate the size
122		local sym_size=$(($sym_end - $sym_base))
123		if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
124			warn "bad symbol size: base: $sym_base end: $sym_end"
125			DONE=1
126			return
127		fi
 
128		sym_size=0x$(printf %x $sym_size)
129
130		# calculate the address
131		local addr=$(($sym_base + $offset))
132		if [[ -z $addr ]] || [[ $addr = 0 ]]; then
133			warn "bad address: $sym_base + $offset"
134			DONE=1
135			return
136		fi
137		addr=0x$(printf %x $addr)
138
139		# weed out non-function symbols
140		if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
141			[[ $print_warnings = 1 ]] &&
142				echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
143			continue
144		fi
145
146		# if the user provided a size, make sure it matches the symbol's size
147		if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
148			[[ $print_warnings = 1 ]] &&
149				echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
150			continue;
151		fi
152
153		# make sure the provided offset is within the symbol's range
154		if [[ $offset -gt $sym_size ]]; then
155			[[ $print_warnings = 1 ]] &&
156				echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
157			continue
158		fi
159
160		# separate multiple entries with a blank line
 
161		[[ $FIRST = 0 ]] && echo
162		FIRST=0
163
164		# pass real address to addr2line
165		echo "$func+$offset/$sym_size:"
166		local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
167		[[ -z $file_lines ]] && return
168
169		# show each line with context
170		echo "$file_lines" | while read -r line
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
171		do
 
172			echo $line
173			n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
174			n1=$[$n-5]
175			n2=$[$n+5]
176			f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
177			awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") {printf("%d\t%s\n", NR, $0)}' $f
178		done
179
180		DONE=1
181
182	done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
183}
184
185[[ $# -lt 2 ]] && usage
186
187objfile=$1
 
 
 
 
188[[ ! -f $objfile ]] && die "can't find objfile $objfile"
189shift
 
 
190
191DIR_PREFIX=supercalifragilisticexpialidocious
192find_dir_prefix $objfile
193
194FIRST=1
195while [[ $# -gt 0 ]]; do
196	func_addr=$1
197	shift
198
199	# print any matches found
200	DONE=0
201	__faddr2line $objfile $func_addr $DIR_PREFIX 0
202
203	# if no match was found, print warnings
204	if [[ $DONE = 0 ]]; then
205		__faddr2line $objfile $func_addr $DIR_PREFIX 1
206		warn "no match for $func_addr"
207	fi
208done
v6.2
  1#!/bin/bash
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# Translate stack dump function offsets.
  5#
  6# addr2line doesn't work with KASLR addresses.  This works similarly to
  7# addr2line, but instead takes the 'func+0x123' format as input:
  8#
  9#   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
 10#   meminfo_proc_show+0x5/0x568:
 11#   meminfo_proc_show at fs/proc/meminfo.c:27
 12#
 13# If the address is part of an inlined function, the full inline call chain is
 14# printed:
 15#
 16#   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
 17#   native_write_msr+0x6/0x27:
 18#   arch_static_branch at arch/x86/include/asm/msr.h:121
 19#    (inlined by) static_key_false at include/linux/jump_label.h:125
 20#    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
 21#
 22# The function size after the '/' in the input is optional, but recommended.
 23# It's used to help disambiguate any duplicate symbol names, which can occur
 24# rarely.  If the size is omitted for a duplicate symbol then it's possible for
 25# multiple code sites to be printed:
 26#
 27#   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
 28#   raw_ioctl+0x5/0x20:
 29#   raw_ioctl at drivers/char/raw.c:122
 30#
 31#   raw_ioctl+0x5/0xb1:
 32#   raw_ioctl at net/ipv4/raw.c:876
 33#
 34# Multiple addresses can be specified on a single command line:
 35#
 36#   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
 37#   type_show+0x10/0x2d:
 38#   type_show at drivers/video/backlight/backlight.c:213
 39#
 40#   free_reserved_area+0x90/0x123:
 41#   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
 42
 43
 44set -o errexit
 45set -o nounset
 46
 
 
 
 
 
 
 
 
 
 
 
 47usage() {
 48	echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
 49	exit 1
 50}
 51
 52warn() {
 53	echo "$1" >&2
 54}
 55
 56die() {
 57	echo "ERROR: $1" >&2
 58	exit 1
 59}
 60
 61READELF="${CROSS_COMPILE:-}readelf"
 62ADDR2LINE="${CROSS_COMPILE:-}addr2line"
 63AWK="awk"
 64GREP="grep"
 65
 66command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
 67command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
 68command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
 69
 70# Try to figure out the source directory prefix so we can remove it from the
 71# addr2line output.  HACK ALERT: This assumes that start_kernel() is in
 72# init/main.c!  This only works for vmlinux.  Otherwise it falls back to
 73# printing the absolute path.
 74find_dir_prefix() {
 75	local objfile=$1
 76
 77	local start_kernel_addr=$(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' |
 78		${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
 79	[[ -z $start_kernel_addr ]] && return
 80
 81	local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
 82	[[ -z $file_line ]] && return
 83
 84	local prefix=${file_line%init/main.c:*}
 85	if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
 86		return
 87	fi
 88
 89	DIR_PREFIX=$prefix
 90	return 0
 91}
 92
 93__faddr2line() {
 94	local objfile=$1
 95	local func_addr=$2
 96	local dir_prefix=$3
 97	local print_warnings=$4
 98
 99	local sym_name=${func_addr%+*}
100	local func_offset=${func_addr#*+}
101	func_offset=${func_offset%/*}
102	local user_size=
103	local file_type
104	local is_vmlinux=0
105	[[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
106
107	if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
108		warn "bad func+offset $func_addr"
109		DONE=1
110		return
111	fi
112
113	# vmlinux uses absolute addresses in the section table rather than
114	# section offsets.
115	local file_type=$(${READELF} --file-header $objfile |
116		${AWK} '$1 == "Type:" { print $2; exit }')
117	if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
118		is_vmlinux=1
119	fi
120
121	# Go through each of the object's symbols which match the func name.
122	# In rare cases there might be duplicates, in which case we print all
123	# matches.
124	while read line; do
125		local fields=($line)
126		local sym_addr=0x${fields[1]}
127		local sym_elf_size=${fields[2]}
128		local sym_sec=${fields[6]}
129		local sec_size
130		local sec_name
131
132		# Get the section size:
133		sec_size=$(${READELF} --section-headers --wide $objfile |
134			sed 's/\[ /\[/' |
135			${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
136
137		if [[ -z $sec_size ]]; then
138			warn "bad section size: section: $sym_sec"
139			DONE=1
140			return
141		fi
142
143		# Get the section name:
144		sec_name=$(${READELF} --section-headers --wide $objfile |
145			sed 's/\[ /\[/' |
146			${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
147
148		if [[ -z $sec_name ]]; then
149			warn "bad section name: section: $sym_sec"
150			DONE=1
151			return
152		fi
153
154		# Calculate the symbol size.
155		#
156		# Unfortunately we can't use the ELF size, because kallsyms
157		# also includes the padding bytes in its size calculation.  For
158		# kallsyms, the size calculation is the distance between the
159		# symbol and the next symbol in a sorted list.
160		local sym_size
161		local cur_sym_addr
162		local found=0
163		while read line; do
164			local fields=($line)
165			cur_sym_addr=0x${fields[1]}
166			local cur_sym_elf_size=${fields[2]}
167			local cur_sym_name=${fields[7]:-}
168
169			if [[ $cur_sym_addr = $sym_addr ]] &&
170			   [[ $cur_sym_elf_size = $sym_elf_size ]] &&
171			   [[ $cur_sym_name = $sym_name ]]; then
172				found=1
173				continue
174			fi
175
176			if [[ $found = 1 ]]; then
177				sym_size=$(($cur_sym_addr - $sym_addr))
178				[[ $sym_size -lt $sym_elf_size ]] && continue;
179				found=2
180				break
181			fi
182		done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
183
184		if [[ $found = 0 ]]; then
185			warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
186			DONE=1
187			return
188		fi
189
190		# If nothing was found after the symbol, assume it's the last
191		# symbol in the section.
192		[[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
193
 
 
194		if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
195			warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
196			DONE=1
197			return
198		fi
199
200		sym_size=0x$(printf %x $sym_size)
201
202		# Calculate the address from user-supplied offset:
203		local addr=$(($sym_addr + $func_offset))
204		if [[ -z $addr ]] || [[ $addr = 0 ]]; then
205			warn "bad address: $sym_addr + $func_offset"
206			DONE=1
207			return
208		fi
209		addr=0x$(printf %x $addr)
210
211		# If the user provided a size, make sure it matches the symbol's size:
212		if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
 
 
 
 
 
 
 
213			[[ $print_warnings = 1 ]] &&
214				echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
215			continue;
216		fi
217
218		# Make sure the provided offset is within the symbol's range:
219		if [[ $func_offset -gt $sym_size ]]; then
220			[[ $print_warnings = 1 ]] &&
221				echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
222			continue
223		fi
224
225		# In case of duplicates or multiple addresses specified on the
226		# cmdline, separate multiple entries with a blank line:
227		[[ $FIRST = 0 ]] && echo
228		FIRST=0
229
230		echo "$sym_name+$func_offset/$sym_size:"
 
 
 
231
232		# Pass section address to addr2line and strip absolute paths
233		# from the output:
234		local args="--functions --pretty-print --inlines --exe=$objfile"
235		[[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
236		local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
237		[[ -z $output ]] && continue
238
239		# Default output (non --list):
240		if [[ $LIST = 0 ]]; then
241			echo "$output" | while read -r line
242			do
243				echo $line
244			done
245			DONE=1;
246			continue
247		fi
248
249		# For --list, show each line with its corresponding source code:
250		echo "$output" | while read -r line
251		do
252			echo
253			echo $line
254			n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
255			n1=$[$n-5]
256			n2=$[$n+5]
257			f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
258			${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
259		done
260
261		DONE=1
262
263	done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn')
264}
265
266[[ $# -lt 2 ]] && usage
267
268objfile=$1
269
270LIST=0
271[[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
272
273[[ ! -f $objfile ]] && die "can't find objfile $objfile"
274shift
275
276${READELF} --section-headers --wide $objfile | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
277
278DIR_PREFIX=supercalifragilisticexpialidocious
279find_dir_prefix $objfile
280
281FIRST=1
282while [[ $# -gt 0 ]]; do
283	func_addr=$1
284	shift
285
286	# print any matches found
287	DONE=0
288	__faddr2line $objfile $func_addr $DIR_PREFIX 0
289
290	# if no match was found, print warnings
291	if [[ $DONE = 0 ]]; then
292		__faddr2line $objfile $func_addr $DIR_PREFIX 1
293		warn "no match for $func_addr"
294	fi
295done